# Serenity

Graphical Unix-like operating system for x86 computers.

## About

I always wondered what it would be like to write my own operating system, but I never took it seriously. Until now.

I've grown tired of cutesy and condescending software that doesn't take itself or the user seriously. This is my effort to bring back the feeling of computing I once knew.

Roughly speaking, the goal here is a marriage between the aesthetic of late-1990s productivity software and the power-user accessibility of late-2000s \*nix. This is a system by me, for me, based on the things I like.

I regularly post raw development videos on [my YouTube channel](https://www.youtube.com/channel/UC3ts8coMP645hZw9JSD3pqQ).

There's also a [Patreon](https://www.patreon.com/serenityos) if you would like to show some support that way.

## Screenshot

![Screenshot as of ef9fbef](https://raw.githubusercontent.com/awesomekling/serenity/master/Meta/screenshot-ef9fbef.png)

## Current features

* Pre-emptive multitasking
* Multithreading
* Compositing window server
* IPv4 networking with ARP, TCP, UDP and ICMP
* ext2 filesystem
* Unix-like libc and userland
* mmap()
* /proc filesystem
* Local sockets
* Pseudoterminals
* Event loop library (LibCore)
* High-level GUI library (LibGUI)
* PNG format support
* Text editor
* IRC client
* DNS lookup
* Minesweeper
* Other stuff I can't think of right now...

## How do I build and run this?

See the [step-by-step guide to building Serenity](https://github.com/awesomekling/serenity/blob/master/Meta/BuildInstructions.md)

## Author

* **Andreas Kling** - [awesomekling](https://github.com/awesomekling)

## License

Serenity is licensed under a 2-clause BSD license.
